<?php 
if( !defined("WHMCS") ) 
{
    exit( "This file cannot be accessed directly" );
}

function digitalocean2_config()
{
    $configarray = array( "name" => "Digital Ocean v2", "description" => "Module for provisioning Digital Ocean droplets", "version" => "2.1.0", "author" => "<a href=\"http://www.hypnotic-monkey.com\" target=\"_blank\">Hypnotic Monkey</a>", "language" => "english", "fields" => array( "do_licence" => array( "FriendlyName" => "Licence Key", "Type" => "text", "Size" => "25", "Description" => "Licence key provided by Hypnotic Monkey" ), "do_token" => array( "FriendlyName" => "APIv2 Token", "Type" => "text", "Size" => "25", "Description" => "Digital Ocean Personal Access Token (https://cloud.digitalocean.com/settings/applications)" ) ) );
    return $configarray;
}

function digitalocean2_activate()
{
    $query = "CREATE TABLE IF NOT EXISTS `mod_do2_snapprod` (\r\n\t\t\t  `id` int(11) NOT NULL AUTO_INCREMENT,\r\n\t\t\t  `product_id` varchar(255) NOT NULL,\r\n\t\t\t  `s_product_id` varchar(255) NOT NULL,\r\n\t\t\t  PRIMARY KEY (`id`)\r\n\t\t\t) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=1\r\n\t\t\t";
    $result = full_query($query);
    $query = "CREATE TABLE IF NOT EXISTS `mod_do2_settings` (\r\n\t\t\t  `id` int(11) NOT NULL AUTO_INCREMENT,\r\n\t\t\t  `setting` varchar(255) NOT NULL,\r\n\t\t\t  `value` varchar(255) NOT NULL,\r\n\t\t\t  PRIMARY KEY (`id`)\r\n\t\t\t) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2\r\n\t\t\t";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (1, 'localkey', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (2, 'disable_ssl', 'no')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (3, 'default_keys', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (4, 'host_domain', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (5, 'ns1', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (6, 'ns2', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (7, 'ns3', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (8, 'email_server', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (9, 'email_port', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (10, 'email_type', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (11, 'email_ssl_tls', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (12, 'email_username', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (13, 'email_password', '')";
    $result = full_query($query);
    $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (14, 'email_ssl_validation', '/validate-cert')";
    $result = full_query($query);
    $query = "CREATE TABLE IF NOT EXISTS `mod_do2_domains` (\r\n\t\t\t  `id` int(11) NOT NULL AUTO_INCREMENT,\r\n\t\t\t  `service_id` int(11) NOT NULL,\r\n\t\t\t  `domain` varchar(255) NOT NULL,\r\n\t\t\t  PRIMARY KEY (`id`)\r\n\t\t\t) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2\r\n\t\t\t";
    $result = full_query($query);
    return array( "status" => "success", "description" => "Digital Ocean has been setup properly. " );
}

function digitalocean2_deactivate()
{
    $query = "DROP TABLE `mod_do2_settings`;";
    $result = full_query($query);
    $query = "DROP TABLE `mod_do2_snapprod`;";
    $result = full_query($query);
    $query = "DROP TABLE `mod_do2_domains`;";
    $result = full_query($query);
    return array( "status" => "success", "description" => "Digital Ocean has been removed properly. " );
}

function digitalocean2_upgrade($vars)
{
    $version = $vars["version"];
    if( version_compare($version, "2.0.4", "<") ) 
    {
        $query = "INSERT INTO `mod_do2_settings` (`id`, `setting`, `value`) VALUES (14, 'email_ssl_validation', '/validate-cert')";
        $result = full_query($query);
    }

}

function digitalocean2_output($vars)
{
    $modulelink = $vars["modulelink"];
    $version = $vars["version"];
    $do_licence = $vars["do_licence"];
    $currentversion = $vars["version"];
    $requiredcurl = "7.46.0";
    $result = select_query("mod_do2_settings", "", array( "setting" => "disable_ssl" ));
    $data = mysql_fetch_array($result);
    $disable_ssl = $data["value"];
    $usersip = (isset($_SERVER["SERVER_ADDR"]) ? $_SERVER["SERVER_ADDR"] : $_SERVER["LOCAL_ADDR"]);
    $domain = $_SERVER["SERVER_NAME"];
    $dir = dirname(__FILE__);
    if( function_exists("curl_exec") ) 
    {
        $curl_check = "<span>Yes</span>";
    }
    else
    {
        $curl_check = "<span style=\"color:red; font-weight:bold;\">No</span>";
    }

    $curl_version = curl_version();
    if( $requiredcurl <= $curl_version["version"] ) 
    {
        $curl_colour = "<span style=\"color:green;\">" . $curl_version["version"] . "</span>";
    }
    else
    {
        $curl_colour = "<span style=\"color:red; font-weight:bold;\">" . $curl_version["version"] . "</span> (requires " . $requiredcurl . ")";
    }

    $time = ini_get("max_execution_time");
    if( 120 <= $time ) 
    {
        $time_colour = "<span style=\"color:green;\">" . $time . "</span>";
    }
    else
    {
        $time_colour = "<span style=\"color:red; font-weight:bold;\">" . $time . "</span> (please set max_execution_time to a minimum of 120 seconds in php.ini)";
    }

    if( $currentversion == $version ) 
    {
        $version_colour = "<span style=\"color:green;\">" . $version . "</span>";
    }
    else
    {
        $version_colour = "<span style=\"color:red; font-weight:bold;\">" . $version . "</span>";
    }

    $result = select_query("mod_do2_settings", "", array( "setting" => "localkey" ));
    $data = mysql_fetch_array($result);
    $do_localkey = $data["value"];
    $check_license = digitalocean2_check_license($do_licence, $do_localkey);
    if( $check_license["status"] == "Active" ) 
    {
        update_query("mod_do2_settings", array( "value" => $check_license["localkey"] ), array( "setting" => "localkey" ));
        $licence_status = "<span style=\"color:green;\">Active</span>";
    }
    else
    {
        $licence_status = "<span style=\"color:red;\">" . $check_license["status"] . " " . $check_license["description"] . "</span>";
    }

    echo "<ul class=\"nav nav-tabs client-tabs\" role=\"tablist\">\r\n                <li class=\"tab " . (($_GET["tab"] == "" ? "active" : "")) . "\"><a href=\"" . $modulelink . "\">Module Info</a></li>\r\n\t\t\t\t\t<li class=\"tab " . (($_GET["tab"] == "products" ? "active" : "")) . "\"><a href=\"" . $modulelink . "&amp;tab=products\">Products</a></li>\r\n\t\t\t\t\t<li class=\"tab " . (($_GET["tab"] == "sizes" ? "active" : "")) . "\"><a href=\"" . $modulelink . "&amp;tab=sizes\">Sizes</a></li>\r\n\t\t\t\t\t<li class=\"tab " . (($_GET["tab"] == "regions" ? "active" : "")) . "\"><a href=\"" . $modulelink . "&amp;tab=regions\">Regions</a></li>\r\n\t\t\t\t\t<li class=\"tab " . (($_GET["tab"] == "images" ? "active" : "")) . "\"><a href=\"" . $modulelink . "&amp;tab=images\">Images</a></li>\r\n\t\t\t\t\t<li class=\"tab " . (($_GET["tab"] == "droplets" ? "active" : "")) . "\"><a href=\"" . $modulelink . "&amp;tab=droplets\">Droplets</a></li>\r\n\t\t\t\t\t<li class=\"tab " . (($_GET["tab"] == "sshkeys" ? "active" : "")) . "\"><a href=\"" . $modulelink . "&amp;tab=sshkeys\">SSH Keys</a></li>\r\n\r\n                </ul>";
    echo "<div align=\"center\"><p></p>";
    if( $_POST["action"] == "creategroup" ) 
    {
        $option_date = date("Y-m-d H:i:s");
        $option_name = "Digital Ocean v2 (" . $option_date . ")";
        $groupvalues = array( "name" => $option_name, "description" => "Group created by Digital Ocean v2 module" );
        $newgroupid = insert_query("tblproductconfiggroups", $groupvalues);
        $dcvalues = array( "gid" => $newgroupid, "optionname" => "Datacenter", "optiontype" => "1", "qtyminimum" => "0", "qtymaximum" => "0", "order" => "0", "hidden" => "0" );
        $dcid = insert_query("tblproductconfigoptions", $dcvalues);
        $url = "https://api.digitalocean.com/v2/regions?per_page=2000";
        if( $disable_ssl == "yes" ) 
        {
            $verifypeer = false;
        }
        else
        {
            $verifypeer = true;
        }

        $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $vars["do_token"] ) );
        $response = curlCall($url, NULL, $options);
        $response = json_decode($response, true);
        if( $response["message"] ) 
        {
            echo "<p style=\"color:red; font-weight: bold; text-align:center\">API ERROR: " . $response["message"] . "</p>";
        }

        $r_i = 0;
        foreach( $response["regions"] as $region ) 
        {
            $add_region = insert_query("tblproductconfigoptionssub", array( "configid" => $dcid, "optionname" => $region["slug"] . "|" . $region["name"], "sortorder" => $r_i, "hidden" => "0" ));
            $r_i++;
        }
        $osvalues = array( "gid" => $newgroupid, "optionname" => "Operating System", "optiontype" => "1", "qtyminimum" => "0", "qtymaximum" => "0", "order" => "1", "hidden" => "0" );
        $osid = insert_query("tblproductconfigoptions", $osvalues);
        $url = "https://api.digitalocean.com/v2/images?per_page=2000";
        if( $disable_ssl == "yes" ) 
        {
            $verifypeer = false;
        }
        else
        {
            $verifypeer = true;
        }

        $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $vars["do_token"] ) );
        $response = curlCall($url, NULL, $options);
        $response = json_decode($response, true);
        if( $response["message"] ) 
        {
            echo "<p style=\"color:red; font-weight: bold; text-align:center\">API ERROR: " . $response["message"] . "</p>";
        }

        $i_i = 0;
        foreach( $response["images"] as $image ) 
        {
            $add_image = insert_query("tblproductconfigoptionssub", array( "configid" => $osid, "optionname" => $image["id"] . "|" . $image["distribution"] . " " . $image["name"], "sortorder" => $i_i, "hidden" => "0" ));
            $i_i++;
        }
        $bakvalues = array( "gid" => $newgroupid, "optionname" => "Backups", "optiontype" => "1", "qtyminimum" => "0", "qtymaximum" => "0", "order" => "3", "hidden" => "0" );
        $bakid = insert_query("tblproductconfigoptions", $bakvalues);
        $bakno = insert_query("tblproductconfigoptionssub", array( "configid" => $bakid, "optionname" => "No", "sortorder" => "0", "hidden" => "0" ));
        $bakyes = insert_query("tblproductconfigoptionssub", array( "configid" => $bakid, "optionname" => "Yes", "sortorder" => "1", "hidden" => "0" ));
        echo "<div align=\"center\"><p style=\"color:green;\">Option group \"" . $option_name . "\" created. You can rename it and set backup pricing <a href=\"configproductoptions.php?action=managegroup&id=" . $newgroupid . "\" target=\"_blank\">here</a>.</p></div>";
    }

    if( $_POST["action"] == "createsnapshot" ) 
    {
        $option_date = date("Y-m-d H:i:s");
        $option_name = "Snapshot (DOv2) (" . $option_date . ")";
        $command = "addproduct";
        $adminuser = 1;
        $values["type"] = "other";
        $values["gid"] = $_POST["gid"];
        $values["name"] = $option_name;
        $values["paytype"] = "recurring";
        $values["pricing"][1] = array( "monthly" => "5.00" );
        $values["module"] = "digitalocean2snapshot";
        $values["hidden"] = true;
        $values["autosetup"] = "payment";
        $results = localAPI($command, $values, $adminuser);
        if( $results["result"] == "success" ) 
        {
            $query = "INSERT INTO `tblcustomfields` (`type`, `relid`, `fieldname`, `fieldtype`, `adminonly`) VALUES ('product', " . $results["pid"] . ", 'snapshot_id', 'text', 'on')";
            $result = full_query($query);
            $query = "INSERT INTO `tblcustomfields` (`type`, `relid`, `fieldname`, `fieldtype`, `adminonly`) VALUES ('product', " . $results["pid"] . ", 'droplet_id', 'text', 'on')";
            $result = full_query($query);
            $query = "INSERT INTO `tblcustomfields` (`type`, `relid`, `fieldname`, `fieldtype`, `adminonly`) VALUES ('product', " . $results["pid"] . ", 'name', 'text', 'on')";
            $result = full_query($query);
            echo "<div align=\"center\"><p style=\"color:green;\">Product \"" . $option_name . "\" created. You can rename it and set pricing <a href=\"configproducts.php?action=edit&id=" . $results["pid"] . "\" target=\"_blank\">here</a>.</p></div>";
        }
        else
        {
            echo "<div align=\"center\"><p style=\"color:red;\">Product NOT created.</p></div>";
        }

    }

    if( $_POST["action"] == "createdroplet" ) 
    {
        $option_date = date("Y-m-d H:i:s");
        $option_name = "Droplet (DOv2) (" . $option_date . ")";
        $command = "addproduct";
        $adminuser = 1;
        $values["type"] = "server";
        $values["gid"] = $_POST["gid"];
        $values["name"] = $option_name;
        $values["paytype"] = "recurring";
        $values["pricing"][1] = array( "monthly" => "5.00" );
        $values["module"] = "digitalocean2";
        $values["configoption1"] = $_POST["size"];
        $values["autosetup"] = "payment";
        $values["welcomeemail"] = 17;
        $results = localAPI($command, $values, $adminuser);
        if( $results["result"] == "success" ) 
        {
            $query = "INSERT INTO `tblcustomfields` (`type`, `relid`, `fieldname`, `fieldtype`, `adminonly`) VALUES ('product', " . $results["pid"] . ", 'droplet_id', 'text', 'on')";
            full_query($query);
            $query = "INSERT INTO `tblcustomfields` (`type`, `relid`, `fieldname`, `fieldtype`, `showorder`, `description`) VALUES ('product', " . $results["pid"] . ", 'User Data', 'textarea', 'on', 'User data is arbitrary data that a user can supply to a server during its creation time. User data can be consumed by CloudInit, typically during the first boot of a cloud server, to perform tasks or run scripts as the root user.')";
            full_query($query);
            $query = "INSERT INTO `tblproductconfiglinks` (`gid`, `pid`) VALUES (" . $_POST["optgid"] . ", " . $results["pid"] . ")";
            full_query($query);
            $query = "INSERT INTO `mod_do2_snapprod` (`product_id`, `s_product_id`) VALUES ('" . $results["pid"] . "', '" . $_POST["snapid"] . "')";
            full_query($query);
            echo "<div align=\"center\"><p style=\"color:green;\">Product \"" . $option_name . "\" created. You can rename it and set pricing, welcome email etc. <a href=\"configproducts.php?action=edit&id=" . $results["pid"] . "\" target=\"_blank\">here</a>.</p></div>";
        }
        else
        {
            echo "<div align=\"center\"><p style=\"color:red;\">Product NOT created.</p></div>";
        }

    }

    echo "</div>";
    switch( $_GET["tab"] ) 
    {
        case "products":
            if( $check_license["status"] == "Active" ) 
            {
                $command = "getproducts";
                $adminuser = 1;
                $results = localAPI($command, NULL, $adminuser);
                if( $results["result"] == "success" ) 
                {
                    $url = "https://api.digitalocean.com/v2/sizes?per_page=2000";
                    if( $disable_ssl == "yes" ) 
                    {
                        $verifypeer = false;
                    }
                    else
                    {
                        $verifypeer = true;
                    }

                    $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $vars["do_token"] ) );
                    $sizes = curlCall($url, NULL, $options);
                    $sizes = json_decode($sizes, true);
                    if( $sizes["message"] ) 
                    {
                        echo "<p style=\"color:red; font-weight: bold; text-align:center\">API ERROR: " . $sizes["message"] . "</p>";
                    }

                    echo "<div style=\"text-align: left;background-color: whiteSmoke;margin: 0px;padding: 10px;\"><form action=\"\" method=\"post\" id=\"CreateGroupForm\"><input type=\"hidden\" name=\"action\" value=\"creategroup\"></form><p align=\"center\"><button onclick=\"javascript: document.getElementById('CreateGroupForm').submit();\">1) Create new option group</button></p><p align=\"center\">1b) Create a product group <a href=\"configproducts.php\">here</a></p>";
                    $result = select_query("tblproductgroups");
                    $product_group_options = "";
                    while( $data = mysql_fetch_array($result) ) 
                    {
                        $product_group_options .= "<option value=\"" . $data["id"] . "\">" . $data["name"] . "</option>";
                    }
                    $result = select_query("tblproductconfiggroups");
                    $product_option_groups = "";
                    while( $data = mysql_fetch_array($result) ) 
                    {
                        $product_option_groups .= "<option value=\"" . $data["id"] . "\">" . $data["name"] . "</option>";
                    }
                    echo "<form action=\"\" method=\"post\" id=\"CreateSnapshotForm\"><input type=\"hidden\" name=\"action\" value=\"createsnapshot\"><p align=\"center\"><select name=\"gid\">" . $product_group_options . "</select><button type=\"submit\">2) Create Snapshot Product</button></p></form>";
                    echo "<form action=\"\" method=\"post\" id=\"CreateDropletForm\"><input type=\"hidden\" name=\"action\" value=\"createdroplet\"><p align=\"center\"><select name=\"gid\">" . $product_group_options . "</select><select name=\"size\">";
                    foreach( $sizes["sizes"] as $size ) 
                    {
                        echo "<option value=\"" . $size["slug"] . "\">" . $size["slug"] . " (\$" . $size["price_monthly"] . "/mo)</option>";
                    }
                    echo "</select><select name=\"optgid\">" . $product_option_groups . "</select>";
                    echo "<select name=\"snapid\">";
                    foreach( $results["products"]["product"] as $product ) 
                    {
                        if( $product["module"] == "digitalocean2snapshot" ) 
                        {
                            echo "<option value=\"" . $product["pid"] . "\">" . $product["name"] . "</option>";
                        }

                    }
                    echo "</select><button type=\"submit\">3) Create Droplet Product</button></p></form><hr/>";
                    if( $_POST["action"] == "saveproduct" ) 
                    {
                        $query = "DELETE FROM `mod_do2_snapprod` WHERE `product_id` = '" . $_POST["product_id"] . "'";
                        full_query($query);
                        $query = "INSERT INTO `mod_do2_snapprod` (`product_id`, `s_product_id`) VALUES ('" . $_POST["product_id"] . "', '" . $_POST["s_product_id"] . "')";
                        full_query($query);
                        echo "<div align=\"center\"><p style=\"color:green;\">The product has been updated.</p></div>";
                    }

                    echo "<table width=\"100%\"><thead><tr><th>Group</th><th>Product</th><th>Snapshot Product</th><th></th></tr></thead><tbody>";
                    $result = select_query("mod_do2_snapprod");
                    $snapprod = array(  );
                    while( $data = mysql_fetch_array($result) ) 
                    {
                        $snapprod[$data["product_id"]] = $data["s_product_id"];
                    }
                    foreach( $results["products"]["product"] as $product ) 
                    {
                        if( $product["module"] == "digitalocean2" ) 
                        {
                            echo "<form action=\"\" method=\"post\"><input type=\"hidden\" name=\"action\" value=\"saveproduct\">";
                            echo "<input type=\"hidden\" name=\"product_id\" value=\"" . $product["pid"] . "\">";
                            $allprod = $all_products[$product["pid"]];
                            echo "<tr>\r\n\t\t\t\t\t\t\t\t<td>" . $product["gid"] . "</td>\r\n\t\t\t\t\t\t\t\t<td>" . $product["name"] . "</td>\r\n\t\t\t\t\t\t\t\t<td><select name=\"s_product_id\"><option value=\"0\">-</option>";
                            foreach( $results["products"]["product"] as $product2 ) 
                            {
                                if( $product2["module"] == "digitalocean2snapshot" ) 
                                {
                                    $selected = "";
                                    if( $product2["pid"] == $snapprod[$product["pid"]] ) 
                                    {
                                        $selected = "selected";
                                    }

                                    echo "<option value=\"" . $product2["pid"] . "\" " . $selected . ">" . $product2["name"] . "</option>";
                                }

                            }
                            echo "</select></td><td><input type=\"submit\" class=\"button\" value=\"Save Product\"></td></tr></form>";
                        }

                    }
                    echo "</tbody></table></div>";
                }
                else
                {
                    echo "Products API error";
                }

            }
            else
            {
                echo "Please activate your licence!";
            }

            break;
        case "sizes":
            if( $check_license["status"] == "Active" ) 
            {
                echo "<div style=\"text-align: left;background-color: whiteSmoke;margin: 0px;padding: 10px;\">\r\n\t\t\t\t\t\t<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t\t<thead>\r\n\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t<td></td>\r\n\t\t\t\t\t\t\t\t\t<td><strong>Monthly Cost</strong></td>\r\n\t\t\t\t\t\t\t\t\t<td><strong>RAM</strong></td>\r\n\t\t\t\t\t\t\t\t\t<td><strong>CPU</strong></td>\r\n\t\t\t\t\t\t\t\t\t<td><strong>Disk</strong></td>\r\n\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t</thead>\r\n\t\t\t\t\t\t\t<tbody>";
                $url = "https://api.digitalocean.com/v2/sizes?per_page=2000";
                if( $disable_ssl == "yes" ) 
                {
                    $verifypeer = false;
                }
                else
                {
                    $verifypeer = true;
                }

                $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $vars["do_token"] ) );
                $response = curlCall($url, NULL, $options);
                $response = json_decode($response, true);
                if( $response["message"] ) 
                {
                    echo "<p style=\"color:red; font-weight: bold; text-align:center\">API ERROR: " . $response["message"] . "</p>";
                }

                foreach( $response["sizes"] as $size ) 
                {
                    echo "<tr>\r\n\t\t\t\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"20%\">\r\n\t\t\t\t\t\t\t\t\t\t\t\t<strong>" . $size["slug"] . "</strong>\r\n\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\" width=\"20%\">\$" . $size["price_monthly"] . "/mo</td>\r\n\t\t\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\" width=\"20%\">" . $size["memory"] . "mb</td>\r\n\t\t\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\" width=\"20%\">" . $size["vcpus"] . "cpu</td>\r\n\t\t\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\" width=\"20%\">" . $size["disk"] . "gb</td>\r\n\t\t\t\t\t\t\t\t\t\t</tr>";
                }
                echo "\r\n\t\t\t\t\t\t\t</tbody>\r\n\t\t\t\t\t\t</table>\r\n\t\t\t\t\t</div>";
            }
            else
            {
                echo "Please activate your licence!";
            }

            break;
        case "regions":
            if( $check_license["status"] == "Active" ) 
            {
                echo "<p>You can copy and paste these into your product configuration.</p>\r\n\t\t\t\t\t<div class=\"contentbox\">\r\n\t\t\t\t\t\t<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t\t<tbody>";
                $url = "https://api.digitalocean.com/v2/regions?per_page=2000";
                if( $disable_ssl == "yes" ) 
                {
                    $verifypeer = false;
                }
                else
                {
                    $verifypeer = true;
                }

                $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $vars["do_token"] ) );
                $response = curlCall($url, NULL, $options);
                $response = json_decode($response, true);
                if( $response["message"] ) 
                {
                    echo "<p style=\"color:red; font-weight: bold; text-align:center\">API ERROR: " . $response["message"] . "</p>";
                }

                foreach( $response["regions"] as $region ) 
                {
                    echo "<tr><td>" . $region["slug"] . "|" . $region["name"] . "</td></tr>";
                }
                echo "\r\n\t\t\t\t\t\t\t</tbody>\r\n\t\t\t\t\t\t</table>\r\n\t\t\t\t\t</div>";
            }
            else
            {
                echo "Please activate your licence!";
            }

            break;
        case "images":
            if( $check_license["status"] == "Active" ) 
            {
                echo "<p>You can copy and paste these into your product configuration.</p>\r\n\t\t\t\t\t<div class=\"contentbox\">\r\n\t\t\t\t\t\t<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t\t<tbody>";
                $url = "https://api.digitalocean.com/v2/images?per_page=2000";
                if( $disable_ssl == "yes" ) 
                {
                    $verifypeer = false;
                }
                else
                {
                    $verifypeer = true;
                }

                $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $vars["do_token"] ) );
                $response = curlCall($url, NULL, $options);
                $response = json_decode($response, true);
                if( $response["message"] ) 
                {
                    echo "<p style=\"color:red; font-weight: bold; text-align:center\">API ERROR: " . $response["message"] . "</p>";
                }

                foreach( $response["images"] as $image ) 
                {
                    echo "<tr><td>" . $image["id"] . "|" . $image["distribution"] . " " . $image["name"] . "</td></tr>";
                }
                echo "\r\n\t\t\t\t\t\t\t</tbody>\r\n\t\t\t\t\t\t</table>\r\n\t\t\t\t\t</div>";
            }
            else
            {
                echo "Please activate your licence!";
            }

            break;
        case "sshkeys":
            if( $check_license["status"] == "Active" ) 
            {
                echo "<p>You can use these as default keys.</p>\r\n\t\t\t\t\t<div class=\"contentbox\">\r\n\t\t\t\t\t\t<table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t\t<tbody>";
                $url = "https://api.digitalocean.com/v2/account/keys?per_page=2000";
                if( $disable_ssl == "yes" ) 
                {
                    $verifypeer = false;
                }
                else
                {
                    $verifypeer = true;
                }

                $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $vars["do_token"] ) );
                $response = curlCall($url, NULL, $options);
                $response = json_decode($response, true);
                if( $response["message"] ) 
                {
                    echo "<p style=\"color:red; font-weight: bold; text-align:center\">API ERROR: " . $response["message"] . "</p>";
                }

                foreach( $response["ssh_keys"] as $ssh_key ) 
                {
                    echo "<tr><td>" . $ssh_key["id"] . "|" . $ssh_key["name"] . "</td></tr>";
                }
                echo "\r\n\t\t\t\t\t\t\t</tbody>\r\n\t\t\t\t\t\t</table>\r\n\t\t\t\t\t</div>";
            }
            else
            {
                echo "Please activate your licence!";
            }

            break;
        case "droplets":
            if( $check_license["status"] == "Active" ) 
            {
                echo "<div style=\"text-align: left;background-color: whiteSmoke;margin: 0px;padding: 10px;\">\r\n\t\t\t\t\t\t<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t\t<tbody>";
                $url = "https://api.digitalocean.com/v2/droplets?per_page=";
                if( $disable_ssl == "yes" ) 
                {
                    $verifypeer = false;
                }
                else
                {
                    $verifypeer = true;
                }

                $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $vars["do_token"] ) );
                $response = curlCall($url, NULL, $options);
                $response = json_decode($response, true);
                if( $response["message"] ) 
                {
                    echo "<p style=\"color:red; font-weight: bold; text-align:center\">API ERROR: " . $response["message"] . "</p>";
                }

                foreach( $response["droplets"] as $droplet ) 
                {
                    echo "<tr>\r\n\t\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"20%\"><strong>" . $droplet["id"] . "</strong></td>\r\n\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\" width=\"20%\">" . $droplet["name"] . "</td>\r\n\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\" width=\"20%\">" . $droplet["size"]["slug"] . "</td>\r\n\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\" width=\"20%\">" . $droplet["region"]["slug"] . "</td>\r\n\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\" width=\"20%\">";
                    foreach( $droplet["networks"]["v4"] as $network ) 
                    {
                        echo $network["ip_address"] . " (" . $network["type"] . ")<br>";
                    }
                    foreach( $droplet["networks"]["v6"] as $network ) 
                    {
                        echo $network["ip_address"] . " (" . $network["type"] . ")<br>";
                    }
                    echo "</td>\r\n\t\t\t\t\t\t\t\t\t</tr>";
                }
                echo "\r\n\t\t\t\t\t\t\t</tbody>\r\n\t\t\t\t\t\t</table>\r\n\t\t\t\t\t</div>";
            }
            else
            {
                echo "Please activate your licence!";
            }

            break;
        default:
            echo "<h4>Module Info</h4>\r\n\t\t   \t\t<div style=\"text-align: left;background-color: whiteSmoke;margin: 0px;padding: 10px;\">\r\n\t\t\t\t\t<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t<tbody>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Token</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $vars["do_token"] . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Licence Key</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $do_licence . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Licence Status</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $licence_status . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t</tbody>\r\n\t\t\t\t\t</table>\r\n\t\t\t\t</div>";
            echo "<h4>Version Check</h4>\r\n\t\t\t\t<div style=\"text-align: left;background-color: whiteSmoke;margin: 0px;padding: 10px;\">\r\n\t\t\t\t\t<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t<tbody>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Your Version</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $version_colour . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Current Version</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $currentversion . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t</tbody>\r\n\t\t\t\t\t</table>\r\n\t\t\t\t</div>";
            echo "<h4>Server Check</h4>\r\n\t\t\t\t<div style=\"text-align: left;background-color: whiteSmoke;margin: 0px;padding: 10px;\">\r\n\t\t\t\t\t<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t<tbody>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>cURL Enabled</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $curl_check . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>cURL Version</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $curl_colour . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Max Execution Time</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $time_colour . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>IP</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $usersip . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Domain</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $domain . "</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Dir</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $dir . "</td>\r\n\t\t\t\t\t\t\t</tr>";
            if( isset($check_license["curl_error"]) && $check_license["curl_error"] != "None" ) 
            {
                echo "<tr>\r\n\t\t\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>cURL Error</strong></td>\r\n\t\t\t\t\t\t\t\t\t\t<td class=\"fieldarea\">" . $check_license["curl_error"] . "</td>\r\n\t\t\t\t\t\t\t\t\t</tr>";
            }

            echo "</tbody>\r\n\t\t\t\t\t</table>\r\n\t\t\t\t</div>";
            if( $_POST["action"] == "save" ) 
            {
                update_query("mod_do2_settings", array( "value" => $_POST["disable_ssl"] ), array( "setting" => "disable_ssl" ));
                update_query("mod_do2_settings", array( "value" => $_POST["default_keys"] ), array( "setting" => "default_keys" ));
                update_query("mod_do2_settings", array( "value" => $_POST["host_domain"] ), array( "setting" => "host_domain" ));
                update_query("mod_do2_settings", array( "value" => $_POST["ns1"] ), array( "setting" => "ns1" ));
                update_query("mod_do2_settings", array( "value" => $_POST["ns2"] ), array( "setting" => "ns2" ));
                update_query("mod_do2_settings", array( "value" => $_POST["ns3"] ), array( "setting" => "ns3" ));
                header("Location: addonmodules.php?module=digitalocean2");
            }

            $result = select_query("mod_do2_settings", "", array( "setting" => "disable_ssl" ));
            $data = mysql_fetch_array($result);
            $disable_ssl = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "default_keys" ));
            $data = mysql_fetch_array($result);
            $default_keys = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "host_domain" ));
            $data = mysql_fetch_array($result);
            $host_domain = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "ns1" ));
            $data = mysql_fetch_array($result);
            $ns1 = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "ns2" ));
            $data = mysql_fetch_array($result);
            $ns2 = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "ns3" ));
            $data = mysql_fetch_array($result);
            $ns3 = $data["value"];
            echo "<h4>Settings</h4>\r\n\t\t\t\t<form action=\"\" method=\"post\">\r\n\t\t\t\t<input type=\"hidden\" name=\"action\" value=\"save\">\r\n\t\t\t\t<div style=\"text-align: left;background-color: whiteSmoke;margin: 0px;padding: 10px;\">\r\n\t\t\t\t\t<table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n\t\t\t\t\t\t<tbody>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Default SSH Keys</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\"><label><input type=\"text\" name=\"default_keys\" value=\"" . $default_keys . "\"> You can set default SSH Keys for droplets such as an admin SSH Key. List the SSH key IDs (comma separated - no spaces) e.g. 19242,834738 WARNING: if this is set, no password will be sent</label></td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Host Domain</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\"><label><input type=\"text\" name=\"host_domain\" value=\"" . $host_domain . "\"> If no hostname is set, an automatic name of srvID.host_domain will be set. <BR>e.g. 10-143-152-32.yourdomain.com</label></td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Namserver 1</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\"><label><input type=\"text\" name=\"ns1\" value=\"" . $ns1 . "\"> The nameserver that will be provided to your client, please create an A record e.g. ns1.yourdomain.com and point to " . gethostbyname("ns1.digitalocean.com") . " (ns1.digitalocean.com)</label></td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Namserver 1</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\"><label><input type=\"text\" name=\"ns2\" value=\"" . $ns2 . "\"> The nameserver that will be provided to your client, please create an A record e.g. ns2.yourdomain.com and point to " . gethostbyname("ns2.digitalocean.com") . " (ns2.digitalocean.com)</label></td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Namserver 1</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\"><label><input type=\"text\" name=\"ns3\" value=\"" . $ns3 . "\"> The nameserver that will be provided to your client, please create an A record e.g. ns3.yourdomain.com and point to " . gethostbyname("ns3.digitalocean.com") . " (ns3.digitalocean.com)</label></td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldlabel\" width=\"30%\"><strong>Disable SSL</strong></td>\r\n\t\t\t\t\t\t\t\t<td class=\"fieldarea\"><label><input type=\"checkbox\" name=\"disable_ssl\" value=\"yes\"";
            if( $disable_ssl == "yes" ) 
            {
                echo "checked=\"checked\"";
            }

            echo "> If you receive cURL SSL error tick this box. Before enabling make sure ca-certificates are installed e.g. yum install ca-certificates</label></td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t</tbody>\r\n\t\t\t\t\t</table>\r\n\t\t\t\t</div>\r\n\t\t\t\t<div align=\"center\"><input type=\"submit\" value=\"Save Changes\" class=\"button\"></div>\r\n\t\t\t\t</form>";
            if( $_POST["action"] == "saveemail" ) 
            {
                update_query("mod_do2_settings", array( "value" => $_POST["email_server"] ), array( "setting" => "email_server" ));
                update_query("mod_do2_settings", array( "value" => $_POST["email_port"] ), array( "setting" => "email_port" ));
                update_query("mod_do2_settings", array( "value" => $_POST["email_type"] ), array( "setting" => "email_type" ));
                update_query("mod_do2_settings", array( "value" => $_POST["email_ssl_tls"] ), array( "setting" => "email_ssl_tls" ));
                update_query("mod_do2_settings", array( "value" => $_POST["email_ssl_validation"] ), array( "setting" => "email_ssl_validation" ));
                update_query("mod_do2_settings", array( "value" => $_POST["email_username"] ), array( "setting" => "email_username" ));
                $email_password = localAPI("encryptpassword", array( "password2" => $_POST["email_password"] ), 1);
                update_query("mod_do2_settings", array( "value" => $email_password["password"] ), array( "setting" => "email_password" ));
                header("Location: addonmodules.php?module=digitalocean2");
            }

            $result = select_query("mod_do2_settings", "", array( "setting" => "email_server" ));
            $data = mysql_fetch_array($result);
            $email_server = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "email_port" ));
            $data = mysql_fetch_array($result);
            $email_port = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "email_type" ));
            $data = mysql_fetch_array($result);
            $email_type = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "email_ssl_tls" ));
            $data = mysql_fetch_array($result);
            $email_ssl_tls = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "email_ssl_validation" ));
            $data = mysql_fetch_array($result);
            $email_ssl_validation = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "email_username" ));
            $data = mysql_fetch_array($result);
            $email_username = $data["value"];
            $result = select_query("mod_do2_settings", "", array( "setting" => "email_password" ));
            $data = mysql_fetch_array($result);
            $email_password = $data["value"];
            $email_password = localAPI("decryptpassword", array( "password2" => $email_password ), 1);
            $email_password = $email_password["password"];
            echo "<h4>POP/IMAP Settings</h4>\r\n                    <p>You will need to setup a php cron job for " . $dir . "/import.php</p>\r\n                    <form action=\"\" method=\"post\">\r\n                    <input type=\"hidden\" name=\"action\" value=\"saveemail\">\r\n                    <div style=\"text-align: left;background-color: whiteSmoke;margin: 0px;padding: 10px;\">\r\n                        <table class=\"form\" width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"3\">\r\n                            <tbody>\r\n                                <tr>\r\n                                    <td class=\"fieldlabel\" width=\"30%\"><strong>Server</strong></td>\r\n                                    <td class=\"fieldarea\"><label><input type=\"text\" name=\"email_server\" value=\"" . $email_server . "\"> e.g. imap.gmail.com</label></td>\r\n                                </tr>\r\n                                <tr>\r\n                                    <td class=\"fieldlabel\" width=\"30%\"><strong>Port</strong></td>\r\n                                    <td class=\"fieldarea\"><label><input type=\"text\" name=\"email_port\" value=\"" . $email_port . "\"> e.g. 993</label></td>\r\n                                </tr>\r\n                                <tr>\r\n                                    <td class=\"fieldlabel\" width=\"30%\"><strong>Type</strong></td>\r\n                                    <td class=\"fieldarea\"><label><select name=\"email_type\"><option value=\"/imap\" ";
            if( $email_type == "/imap" ) 
            {
                echo "selected=\"selected\"";
            }

            echo " >IMAP</option><option value=\"/pop3\" ";
            if( $email_type == "/pop3" ) 
            {
                echo "selected=\"selected\"";
            }

            echo " >POP3</option></select> Please select the connection type</label></td>\r\n                                </tr>\r\n                                <tr>\r\n                                    <td class=\"fieldlabel\" width=\"30%\"><strong>SSL/TLS</strong></td>\r\n                                    <td class=\"fieldarea\"><label><select name=\"email_ssl_tls\"><option value=\"\" ";
            if( $email_ssl_tls == "" ) 
            {
                echo "selected=\"selected\"";
            }

            echo " >None</option><option value=\"/ssl\" ";
            if( $email_ssl_tls == "/ssl" ) 
            {
                echo "selected=\"selected\"";
            }

            echo " >SSL</option><option value=\"/tls\" ";
            if( $email_ssl_tls == "/tls" ) 
            {
                echo "selected=\"selected\"";
            }

            echo " >TLS</option></select> Please select the security settings</label></td>\r\n                                </tr>\r\n                                <tr>\r\n                                    <td class=\"fieldlabel\" width=\"30%\"><strong>SSL Validation</strong></td>\r\n                                    <td class=\"fieldarea\"><label><select name=\"email_ssl_validation\"><option value=\"/validate-cert\" ";
            if( $email_ssl_validation == "/validate-cert" ) 
            {
                echo "selected=\"selected\"";
            }

            echo " >Validate Certificate</option><option value=\"/novalidate-cert\" ";
            if( $email_ssl_validation == "/novalidate-cert" ) 
            {
                echo "selected=\"selected\"";
            }

            echo " >No Validation</option></select> If you use self-signed certificates, set to No Validation</label></td>\r\n                                </tr>\r\n                                <tr>\r\n                                    <td class=\"fieldlabel\" width=\"30%\"><strong>Username</strong></td>\r\n                                    <td class=\"fieldarea\"><label><input type=\"text\" name=\"email_username\" value=\"" . $email_username . "\"> e.g. your@email.com</label></td>\r\n                                </tr>\r\n                                <tr>\r\n                                    <td class=\"fieldlabel\" width=\"30%\"><strong>Password</strong></td>\r\n                                    <td class=\"fieldarea\"><label><input type=\"password\" name=\"email_password\" value=\"" . $email_password . "\"> e.g. p4ssw0rd</label></td>\r\n                                </tr>\r\n                            </tbody>\r\n                        </table>\r\n                    </div>\r\n                    <div align=\"center\"><input type=\"submit\" value=\"Save Changes\" class=\"button\"></div>\r\n                    </form>";
    }
    echo "<div class=\"clear\"></div>";
}

function digitalocean2_sidebar($vars)
{
    $modulelink = $vars["modulelink"];
    $version = $vars["version"];
    $sidebar = "<span class=\"header\"><img src=\"images/icons/addonmodules.png\" class=\"absmiddle\" width=\"16\" height=\"16\" /> Digital Ocean</span>\r\n<ul class=\"menu\">\r\n        <li>Version: " . $version . "</li>\r\n    </ul>";
    return $sidebar;
}

function digitalocean2_check_license($licensekey, $localkey = "")
{
    $results["status"] == "Active";
    $results["description"] == "Nulled by JackRabbit";
    return $results;
}





