<div id="processing" style="display: none;">
    <h3>Action Processing..</h3>
    <div class="progress">
        <div class="progress-bar progress-bar-striped active" role="progressbar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width: 0%;">
        </div>
    </div>
    <p class="text-center"><a href="clientarea.php?action=productdetails&id={$serviceid}">Refresh/Check Progress</a></p>
</div>

<div id="information">
    {if $systemStatus == 'Active'}

        <div class="tiles clearfix">
            <div class="row">
                <div class="col-sm-6 col-xs-12 tile" style="cursor: default;">
                        <!--<div class="icon"><i class="fa fa-cog"></i></div>-->
                        <div class="stat" style="color: #058;">{$droplet_status}</div>
                        <div class="title">Status</div>
                        <div class="highlight bg-color-green"></div>
                </div>
                <div class="col-sm-6 col-xs-12 tile" style="cursor: default;">
                        <!--<div class="icon"><i class="fa fa-globe"></i></div>-->
                        <div class="stat" style="color: #058;">{$dedicatedip}</div>
                        <div class="title">Primary IP</div>
                        <div class="highlight bg-color-blue"></div>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-sm-6 col-xs-12 tile">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Specification</h3>
                    </div>
                    <div class="panel-body">
                        <table class="table">
                            <tr>
                                <th>Hostname</th>
                                <td>{$droplet_information.name}</td>
                            </tr>
                            <tr>
                                <th>Memory</th>
                                <td>{$droplet_information.memory}Mb</td>
                            </tr>
                            <tr>
                                <th>vCPU</th>
                                <td>{$droplet_information.vcpus}</td>
                            </tr>
                            <tr>
                                <th>Disk</th>
                                <td>{$droplet_information.disk}Gb</td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-xs-12 tile">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Information</h3>
                    </div>
                    <div class="panel-body">
                        <table class="table">
                            <tr>
                                <th>Status</th>
                                <td><span class="label {if $droplet_information.status eq 'active'}label-success{else}label-danger{/if}">{$droplet_information.status}</span></td>
                            </tr>
                            <tr>
                                <th>Location</th>
                                <td>{$droplet_information.region.name}</td>
                            </tr>
                            <tr>
                                <th>Operating System</th>
                                <td>{$droplet_information.image.distribution} {$droplet_information.image.name}</td>
                            </tr>

                            <tr>
                                <th>Kernel Version</th>
                                <td>{$droplet_information.kernel.version}</td>
                            </tr>
                        </table>
                    </div>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-sm-4 col-xs-12">
                <div class="panel panel-primary">
                    <div class="panel-heading">
                        <h3 class="panel-title">Power On</h3>
                    </div>
                    <div class="panel-body text-center">
                        <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                            <input type="hidden" name="function" value="poweron" />
                            <button class="btn btn-default btn-lg" type="submit" onclick="return confirm('This action will boot your server. Do you want to proceed?')" {if $droplet_status neq 'off'}disabled{/if}><i class="fa fa-2x fa-play"></i></button>
                        </form>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 col-xs-12">
                <div class="panel panel-primary">
                    <div class="panel-heading">
                        <h3 class="panel-title">Power Off</h3>
                    </div>
                    <div class="panel-body text-center">
                        <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                            <input type="hidden" name="function" value="poweroff" />
                            <button class="btn btn-default btn-lg" onclick="return confirm('This will power off your server. We recommend shutting down your server through the command line. This action is the same as cutting power to the server, and may cause data corruption. Do you want to proceed?')" {if $droplet_status eq 'off'}disabled{/if}><i class="fa fa-2x fa-power-off"></i></button>
                        </form>
                    </div>
                </div>
            </div>
            <div class="col-sm-4 col-xs-12">
                <div class="panel panel-primary">
                    <div class="panel-heading">
                        <h3 class="panel-title">Power Cycle</h3>
                    </div>
                    <div class="panel-body text-center">
                        <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                            <input type="hidden" name="function" value="reboot" />
                            <button class="btn btn-default btn-lg" onclick="return confirm('This action is equivalent to hard resetting the server, which can cause data corruption. You should do this only if you are unable to reboot your server from the command line. Do you want to proceed?')" {if $droplet_status eq 'off'}disabled{/if}><i class="fa fa-2x fa-refresh"></i></button>
                        </form>
                    </div>
                </div>
            </div>
        </div>

        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title">Network</h3>
            </div>
            <div class="panel-body">
                <table class="table table-condensed">
                    <thead>
                        <tr>
                            <th>Version</th>
                            <th>Type</th>
                            <th>IP Address</th>
                            <th>Netmask</th>
                            <th>Gateway</th>
                        </tr>
                    </thead>
                    <tbody>
                        {foreach key=key item=v4 from=$droplet_ipv4}
                            <tr>
                                <td>v4</td>
                                <td>{$v4.type}</td>
                                <td>{$v4.ip_address}</td>
                                <td>{$v4.netmask}</td>
                                <td>{$v4.gateway}</td>
                            </tr>
                        {/foreach}
                        {foreach key=key item=v6 from=$droplet_ipv6}
                            <tr>
                                <td>v6</td>
                                <td>{$v6.type}</td>
                                <td>{$v6.ip_address}</td>
                                <td>/{$v6.netmask}</td>
                                <td>{$v6.gateway}</td>
                            </tr>
                        {/foreach}
                    </tbody>
                </table>
            </div>
        </div>

        <div class="row">
            <div class="col-sm-6 col-xs-12">

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Nameservers</h3>
                    </div>
                    <div class="panel-body">
                        <p>You will need to set your nameservers to the following:</p>
                        <table class="table table-condensed">
                            <tbody>
                            <tr>
                                <td>NS1</td>
                                <td>{$do_ns.ns1}</td>
                            </tr>
                            <tr>
                                <td>NS2</td>
                                <td>{$do_ns.ns2}</td>
                            </tr>
                            <tr>
                                <td>NS3</td>
                                <td>{$do_ns.ns3}</td>
                            </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-xs-12">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Modify DNS</h3>
                    </div>
                    <div class="panel-body">
                        <p class="text-center">
                            <button class="btn btn-default" type="button" data-toggle="modal" data-target="#adddomain">Add Domain</button>
                            <button class="btn btn-default" type="button" data-toggle="modal" data-target="#adddomainrecord" {if !$domains}disabled{/if}>Add Domain Record</button>
                        </p>
                            <hr>
                        <p class="text-center">
                            <button class="btn btn-danger" type="button" data-toggle="modal" data-target="#deletedomain" {if !$domains}disabled{/if}>Delete Domain</button>
                        </p>
                    </div>
                </div>
            </div>
        </div>

        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title">Domain Records</h3>
            </div>
            <div class="panel-body">
                <table class="table">
                    <thead>
                    <tr>
                        <th>Domain</th>
                        <th>Type</th>
                        <th>Name</th>
                        <th>Data</th>
                        <th>Priority</th>
                        <th></th>
                    </tr>
                    </thead>
                    <tbody>
                    {foreach key=key item=domain from=$domains}
                        {foreach key=key item=record from=$domain.records}
                            {if $record.type neq 'NS'}
                                <tr><td>{$domain.name}</td><td>{$record.type}</td><td>{$record.name}</td><td>{$record.data}</td><td>{$record.priority}</td><td><form method="post" action="clientarea.php?action=productdetails&id={$serviceid}"><input type="hidden" name="domain" value="{$domain.name}" /><input type="hidden" name="record_id" value="{$record.id}" /><input type="hidden" name="function" value="deletedomainrecord" /><button class="btn btn-danger btn-xs" type="submit" onclick="return confirm('Are you sure? This will remove the domain record!')"><i class="fa fa-trash"></i></button></form></td></tr>
                            {/if}
                        {/foreach}
                    {/foreach}
                    </tbody>
                </table>
            </div>
        </div>

        <!-- Domain Modals -->
        <div class="modal fade" id="adddomain" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                            <h4 class="modal-title" id="myModalLabel">Add Domain</h4>
                        </div>
                        <div class="modal-body">
                            <input name="domain" placeholder="e.g. domain.com">
                            <input name="ip_address" placeholder="e.g. 127.0.0.1">
                            <input type="hidden" name="function" value="adddomain" />
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Save domain</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <div class="modal fade" id="adddomainrecord" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                            <h4 class="modal-title" id="myModalLabel">Add Domain Record</h4>
                        </div>
                        <div class="modal-body">
                            <p align="left"><br>
                                Add a record for
                                <select name="domain">
                                    {foreach key=key item=domain from=$domains}
                                        <option value="{$domain.name}">{$domain.name}</option>
                                    {/foreach}
                                </select>
                            </p>
                            <table class="table table-condensed">
                                <thead>
                                <tr>
                                    <th>Type</th>
                                    <th id="r1text">Hostname</th>
                                    <th id="r2text">IP</th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr>
                                    <td>
                                        <select name="type" id="domainrecordtype">
                                            <option value="A">A</option>
                                            <option value="AAAA">AAAA</option>
                                            <option value="CNAME">CNAME</option>
                                            <option value="MX">MX</option>
                                        </select>
                                    </td>
                                    <td>
                                        <input name="record1" id="record1" placeholder="e.g. www">
                                    </td>
                                    <td>
                                        <input name="record2" id="record2" placeholder="e.g. 127.0.0.1">
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                            <input type="hidden" name="function" value="adddomainrecord" />
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Save record</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <div class="modal fade" id="deletedomain" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
            <div class="modal-dialog" role="document">
                <div class="modal-content">
                    <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                            <h4 class="modal-title" id="myModalLabel">Delete Domain</h4>
                        </div>
                        <div class="modal-body">
                            <p><br>
                                Delete domain
                                <select name="domain">
                                    {foreach key=key item=domain from=$domains}
                                        <option value="{$domain.name}">{$domain.name}</option>
                                    {/foreach}
                                </select>
                            </p>
                            <input type="hidden" name="function" value="deletedomain" />
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-danger" onclick="return confirm('Are you sure? This will remove all domain records!')">Delete domain</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
        <!-- END Domain Modals -->

        <div class="row">
            <div class="col-sm-6 col-xs-12 tile">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Take Snapshot</h3>
                    </div>
                    <div class="panel-body">
                        {if $droplet_status eq 'off'}
                            <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                                <input type="hidden" name="function" value="createsnapshot" />
                                <p>Please select a payment method:</p>
                                <div align="center">
                                    <div class="btn-group" data-toggle="buttons">
                                        {foreach key=key item=method from=$payment_methods}
                                            <label class="btn btn-primary">
                                                <input type="radio" name="paymentmethod" value="{$method.module}" autocomplete="off" required> {$method.displayname}
                                            </label>
                                        {/foreach}
                                    </div>
                                </div>
                                    <p>The snapshot will be created as soon as payment has been received:</p>
                                <div align="center">
                                    <input class="btn btn-default" type="submit" value="Continue to payment..." alt="Continue to payment..." />
                                </div>
                            </form>
                            <p><br></p>
                        {else}
                            <p>Power off your server to create a snapshot.</p>
                        {/if}
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-xs-12 tile">
                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Rebuild from Snapshot</h3>
                    </div>
                    <div class="panel-body">
                        {if $snapshots}
                            <div align="center">
                                <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                                    <select name="image">
                                        {foreach key=key item=snapshot from=$snapshots}
                                            <option value="{$snapshot.id}">{$snapshot.name}</option>
                                        {/foreach}
                                    </select>
                                    <input type="hidden" name="function" value="rebuild" />
                                    <input class="btn" style="margin-top:-10px;" type="submit" value="Rebuild" alt="Rebuild" onclick="return confirm('Are you sure? This will wipe all data!')" />
                                </form>
                            </div>
                        {else}
                            <p>You do not have any snapshots to restore from</p>
                        {/if}
                    </div>
                </div>
            </div>
        </div>

        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title">Backups</h3>
            </div>
            <div class="panel-body">
                {if $backups_enabled eq 'Yes'}
                    {if $backups}
                        <div align="center">
                            <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                                <select name="image">
                                    {foreach key=key item=backup from=$backups}
                                        <option value="{$backup.id}">{$backup.name}</option>
                                    {/foreach}
                                </select>
                                <input type="hidden" name="function" value="restore" />
                                <input class="btn" style="margin-top:-10px;" type="submit" value="Restore Backup" alt="Restore Backup" onclick="return confirm('Are you sure? This will wipe all data!')" />
                            </form>
                        </div>
                    {else}
                        You currently don't have any backups for this server. Backups will happen automatically every week.
                    {/if}
                {else}
                    <p>Backups are not enabled on this server. Backups can only be enabled when the server is created.</p>
                {/if}
            </div>
        </div>



                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Rename</h3>
                    </div>
                    <div class="panel-body">
                        <p>This will update the displayed domain of your server and the PTR record. You will need to change the hostname in the server manually.</p>
                        <span style="text-align: center;">
                            <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                                <input type="hidden" name="function" value="rename" />
                                <div class="input-append">
                                    <input name="hostname" value="{$domain}" type="text">
                                    <button class="btn" type="submit" onclick="return confirm('Are you sure you want to change the rDNS?')">Rename</button>
                                </div>
                            </form>
                        </span>
                    </div>
                </div>

                <div class="panel panel-default">
                    <div class="panel-heading">
                        <h3 class="panel-title">Change Kernel</h3>
                    </div>
                    <div class="panel-body">
                        {if $kernels}
                            <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                                <select name="kernel">
                                    {foreach key=key item=kernel from=$kernels}
                                        <option value="{$kernel.id}">{$kernel.name} ({$kernel.version})</option>
                                    {/foreach}
                                </select>
                                <input type="hidden" name="function" value="changekernel" />
                                <input class="btn" style="margin-top:-10px;" type="submit" value="Change" alt="Change" onclick="return confirm('Are you sure?')" />
                            </form>
                        {else}
                            There are no alternative kernels available for your server.
                        {/if}
                    </div>
                </div>

        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title">Rebuild Server</h3>
            </div>
            <div class="panel-body">
                <div align="center">
                    <table border="0" cellpadding="0" cellspacing="0">
                        <tbody>
                        <tr>
                            <td style="width: 100%;text-align:center;vertical-align:top;">
                                <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                                    {$imgselect}
                                    <input type="hidden" name="function" value="rebuild" />
                                    <input class="btn" style="margin-top:-10px;" type="submit" value="Rebuild" alt="Rebuild" onclick="return confirm('Are you sure? This will wipe all data!')" />
                                </form>
                            </td>
                        </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>

        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title">Action History</h3>
            </div>
            <div class="panel-body">
                <p>These are the recent actions the that have been performed on the server. You will need to refresh the page to update.</p>
                <table class="table" id="actions-table">
                    <thead>
                    <tr>
                        <th>Event</th>
                        <th>Status</th>
                        <th>Initiated</th>
                        <th>Execution Time</th>
                    </tr>
                    </thead>
                    <tbody>
                    {foreach key=key item=event from=$events}
                        <tr>
                            <td>{$event.type}</td>
                            <td>{$event.status}</td>
                            <td><span class="timeago" title="{$event.started_at}">{$event.started_at}</span></td>
                            <td>{$event.completed_at} seconds</td>
                        </tr>
                    {/foreach}
                    </tbody>
                </table>
            </div>
        </div>

    {else}

        <div class="alert alert-warning text-center" role="alert">
            {if $suspendreason}
                <strong>{$suspendreason}</strong><br />
            {/if}
            {$LANG.cPanel.packageNotActive} {$status}.<br />
            {if $systemStatus eq "Pending"}
                {$LANG.cPanel.statusPendingNotice}
            {elseif $systemStatus eq "Suspended"}
                {$LANG.cPanel.statusSuspendedNotice}
            {/if}
        </div>

    {/if}

    <div class="panel panel-default">
        <div class="panel-heading">
            <h3 class="panel-title">{$LANG.cPanel.billingOverview}</h3>
        </div>
        <div class="panel-body">

            <div class="row">
                <div class="col-md-6">
                    <div class="row">
                        {if $firstpaymentamount neq $recurringamount}
                        <div class="col-xs-6 text-right">
                            {$LANG.firstpaymentamount}
                        </div>
                        <div class="col-xs-6">
                            {$firstpaymentamount}
                        </div>
                    </div>
                    <div class="row">
                        {/if}
                        {if $billingcycle != $LANG.orderpaymenttermonetime && $billingcycle != $LANG.orderfree}
                        <div class="col-xs-6 text-right">
                            {$LANG.recurringamount}
                        </div>
                        <div class="col-xs-6">
                            {$recurringamount}
                        </div>
                    </div>
                    <div class="row">
                        {/if}
                        <div class="col-xs-6 text-right">
                            {$LANG.orderbillingcycle}
                        </div>
                        <div class="col-xs-6">
                            {$billingcycle}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 text-right">
                            {$LANG.orderpaymentmethod}
                        </div>
                        <div class="col-xs-6">
                            {$paymentmethod}
                        </div>
                    </div>
                </div>
                <div class="col-md-6">
                    <div class="row">
                        <div class="col-xs-6 col-md-5 text-right">
                            {$LANG.clientareahostingregdate}
                        </div>
                        <div class="col-xs-6 col-md-7">
                            {$regdate}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 col-md-5 text-right">
                            {$LANG.clientareahostingnextduedate}
                        </div>
                        <div class="col-xs-6 col-md-7">
                            {$nextduedate}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-xs-6 col-md-5 text-right">
                            {$LANG.clientareastatus}
                        </div>
                        <div class="col-xs-6 col-md-7">
                            {$status}
                        </div>
                    </div>
                </div>
            </div>

        </div>
    </div>

    <hr>

    <div class="row">
        {if $packagesupgrade}
            <div class="col-sm-6">
                <a href="upgrade.php?type=package&amp;id={$id}" class="btn btn-success btn-block">
                    Resize Server
                </a>
            </div>
        {/if}

        <div class="col-sm-6">
            <form method="post" action="clientarea.php?action=productdetails&id={$serviceid}">
                <input type="hidden" name="function" value="destroy" />
                <button class="btn btn-danger btn-block{if $pendingcancellation}disabled{/if}" type="submit" onclick="return confirm('This is irreversible. We will destroy your server and all associated backups.')">
                    {if $pendingcancellation}
                        {$LANG.cancellationrequested}
                    {else}
                        Destroy Server
                    {/if}
                </button>
            </form>
        </div>
    </div>

</div>
{literal}
    <script type="text/javascript" src="modules/servers/digitalocean2/js/jquery.timeago.js"></script>
    <script>
        jQuery(document).ready(function(){
            jQuery("span.timeago").timeago();

            if(jQuery('#actions-table').colCheck(2, 'in-progress') > 0) {
                jQuery("#processing").show();
                jQuery("#information").hide();
                jQuery(".progress-bar").width('100%');

                setTimeout(function(){
                    window.location.reload();
                }, 5000);
            }
        });

        jQuery.fn.colCheck = function(col, text) {
            var c = Array.isArray(col) ? col : [col],
                    t = this,
                    a = [];

            jQuery.each(c, function(_, v){
                a.push(
                        t.find('tr td').filter(function() {
                            return jQuery(this).index() === (v-1) && jQuery.trim(jQuery(this).text()) === text;
                        }).length
                );
            });
            return a.length === 1 ? a[0] : a;
        }


        jQuery('#domainrecordtype').on('change', function() {
            var recordtype = jQuery(this).val()

            if(recordtype == "A") {
                jQuery('#r1text').text('Hostname');
                jQuery('#r2text').text('IP');
                jQuery('#record1').attr("placeholder", "e.g. subdomain");
                jQuery('#record2').attr("placeholder", "e.g. 127.0.0.1");
            } else if(recordtype == "AAAA") {
                jQuery('#r1text').text('Hostname');
                jQuery('#r2text').text('IP');
                jQuery('#record1').attr("placeholder", "e.g. www");
                jQuery('#record2').attr("placeholder", "e.g. ::1");
            } else if(recordtype == "CNAME") {
                jQuery('#r1text').text('Hostname');
                jQuery('#r2text').text('Domain');
                jQuery('#record1').attr("placeholder", "e.g. cpanel");
                jQuery('#record2').attr("placeholder", "e.g. cp.domain.com.");
            } else if(recordtype == "MX") {
                jQuery('#r1text').text('Priority');
                jQuery('#r2text').text('Domain');
                jQuery('#record1').attr("placeholder", "e.g. 10");
                jQuery('#record2').attr("placeholder", "e.g. mail.domain.com.");
            }
        });
    </script>
{/literal}