<?php 
function digitalocean2snapshot_getDisableSsl()
{
    $result = select_query("mod_do2_settings", "", array( "setting" => "disable_ssl" ));
    $data = mysql_fetch_array($result);
    return $data["value"];
}

function digitalocean2snapshot_getDoToken()
{
    $result = select_query("tbladdonmodules", "", array( "module" => "digitalocean2", "setting" => "do_token" ));
    $data = mysql_fetch_array($result);
    return $data["value"];
}

function digitalocean2snapshot_ConfigOptions()
{
    $configarray = array(  );
    return $configarray;
}

function digitalocean2snapshot_CreateAccount($params)
{
    $serviceid = $params["serviceid"];
    $pid = $params["pid"];
    $droplet_id = $params["customfields"]["droplet_id"];
    $name = $params["customfields"]["name"];
    $disable_ssl = digitalocean2snapshot_getdisablessl();
    $do_token = digitalocean2snapshot_getdotoken();
    $url = "https://api.digitalocean.com/v2/droplets/" . $droplet_id . "/actions";
    $postfields = array( "type" => "snapshot", "snapshot" => true, "name" => $name );
    if( $disable_ssl == "yes" ) 
    {
        $verifypeer = false;
    }
    else
    {
        $verifypeer = true;
    }

    $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $do_token ) );
    $response = curlCall($url, $postfields, $options);
    $response = json_decode($response, true);
    logModuleCall("digitalocean2snapshot", "create", $postfields, $response, NULL, NULL);
    if( $response["action"] ) 
    {
        $result = "success";
    }
    else
    {
        $result = "API error. " . $response["message"];
    }

    return $result;
}

function digitalocean2snapshot_TerminateAccount($params)
{
    $serviceid = $params["serviceid"];
    $pid = $params["pid"];
    $name = $params["customfields"]["name"];
    $disable_ssl = digitalocean2snapshot_getdisablessl();
    $do_token = digitalocean2snapshot_getdotoken();
    $url = "https://api.digitalocean.com/v2/images?per_page=2000";
    if( $disable_ssl == "yes" ) 
    {
        $verifypeer = false;
    }
    else
    {
        $verifypeer = true;
    }

    $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $do_token ) );
    $response = curlCall($url, NULL, $options);
    $response = json_decode($response, true);
    logModuleCall("digitalocean2snapshot", "getimages", $postfields, $response, NULL, NULL);
    if( !empty($response["images"]) ) 
    {
        foreach( $response["images"] as $image ) 
        {
            if( $image["name"] == $name ) 
            {
                $url = "https://api.digitalocean.com/v2/images/" . $image["id"];
                if( $disable_ssl == "yes" ) 
                {
                    $verifypeer = false;
                }
                else
                {
                    $verifypeer = true;
                }

                $curl = curl_init($url);
                curl_setopt($curl, CURLOPT_CUSTOMREQUEST, "DELETE");
                curl_setopt($curl, CURLOPT_HEADER, false);
                $headers = array( "Authorization: Bearer " . $do_token );
                curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
                curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, $verifypeer);
                curl_exec($curl);
                $httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
                logModuleCall("digitalocean2snapshot", "deletesnapshot (" . $image["id"] . ")", NULL, $httpCode, NULL, NULL);
                if( $httpCode == "204" ) 
                {
                    $result = "success";
                }
                else
                {
                    $result = "ERROR! Could not destroy the snapshot.";
                    $command = "sendadminemail";
                    $adminuser = 1;
                    $values["customsubject"] = "WHMCS: Error deleting snapshot";
                    $values["custommessage"] = "<p>Deleting snapshot failed.</p> <p><strong>Service:</strong> " . $serviceid . "</p> <p><strong>Snapshot ID:</strong> <br>" . $image["id"] . "</p><p><strong>Snapshot Name:</strong> <br>" . $image["name"] . "</p>";
                    $values["type"] = "system";
                    localAPI($command, $values, $adminuser);
                }

            }

        }
    }
    else
    {
        $result = "ERROR! Could not destroy the snapshot. " . $response["message"];
        $command = "sendadminemail";
        $adminuser = 1;
        $values["customsubject"] = "WHMCS: Error deleting snapshot";
        $values["custommessage"] = "<p>Deleting snapshot failed.</p> <p><strong>Service:</strong> " . $serviceid . "</p> <p><strong>Snapshot ID:</strong> <br>" . $snapshot["id"] . "</p><p><strong>Snapshot Name:</strong> <br>" . $snapshot["name"] . "</p>";
        $values["type"] = "system";
        localAPI($command, $values, $adminuser);
    }

    return $result;
}

function digitalocean2snapshot_ClientArea($params)
{
    $alert_error = "";
    $serviceid = $params["serviceid"];
    $pid = $params["pid"];
    $disable_ssl = digitalocean2snapshot_getdisablessl();
    $do_token = digitalocean2snapshot_getdotoken();
    if( $_POST["function"] == "distribute" ) 
    {
        $function = digitalocean2snapshot_distribute($params);
        if( $function == "success" ) 
        {
            header("Location: clientarea.php?action=productdetails&id=" . $serviceid);
        }
        else
        {
            $alert_error .= $function;
        }

    }
    else
    {
        if( $_POST["function"] == "destroy" ) 
        {
            $command = "moduleterminate";
            $adminuser = 1;
            $values["accountid"] = $serviceid;
            $function = localAPI($command, $values, $adminuser);
            if( $function["result"] == "success" ) 
            {
                header("Location: clientarea.php?action=productdetails&id=" . $serviceid);
            }
            else
            {
                $alert_error .= $function["message"];
            }

        }

    }

    return array( "templatefile" => "clientarea", "vars" => array( "alert_error" => $alert_error ) );
}

function digitalocean2snapshot_distribute($params)
{
    $serviceid = $params["serviceid"];
    $pid = $params["pid"];
    $name = $params["customfields"]["name"];
    $disable_ssl = digitalocean2snapshot_getdisablessl();
    $do_token = digitalocean2snapshot_getdotoken();
    $url = "https://api.digitalocean.com/v2/regions?per_page=2000";
    if( $disable_ssl == "yes" ) 
    {
        $verifypeer = false;
    }
    else
    {
        $verifypeer = true;
    }

    $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $do_token ) );
    $response = curlCall($url, NULL, $options);
    $regions = json_decode($response, true);
    logModuleCall("digitalocean2snapshot", "getregions", $postfields, $regions, NULL, NULL);
    $url = "https://api.digitalocean.com/v2/images?per_page=2000";
    if( $disable_ssl == "yes" ) 
    {
        $verifypeer = false;
    }
    else
    {
        $verifypeer = true;
    }

    $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $do_token ) );
    $response = curlCall($url, NULL, $options);
    $response = json_decode($response, true);
    logModuleCall("digitalocean2snapshot", "getimages", $postfields, $response, NULL, NULL);
    if( !empty($response["images"]) ) 
    {
        foreach( $response["images"] as $image ) 
        {
            if( $image["name"] == $name ) 
            {
                $snapshot_id = $image["id"];
                logModuleCall("digitalocean2snapshot", "snapshotfound", $name, $snapshot_id, NULL, NULL);
            }

        }
    }

    if( !empty($snapshot_id) ) 
    {
        if( !empty($regions["regions"]) ) 
        {
            foreach( $regions["regions"] as $region ) 
            {
                $url = "https://api.digitalocean.com/v2/images/" . $snapshot_id . "/actions";
                $postfields = array( "type" => "transfer", "region" => $region["slug"] );
                if( $disable_ssl == "yes" ) 
                {
                    $verifypeer = false;
                }
                else
                {
                    $verifypeer = true;
                }

                $options = array( "CURLOPT_SSL_VERIFYPEER" => $verifypeer, "HEADER" => array( "Authorization: Bearer " . $do_token ) );
                $response2 = curlCall($url, $postfields, $options);
                $response2 = json_decode($response2, true);
                logModuleCall("digitalocean2snapshot", "transfer (" . $snapshot_id . ")", $postfields, $response2, NULL, NULL);
                if( !empty($response2["action"]["id"]) ) 
                {
                    $result = "success";
                }
                else
                {
                    $result = "Could not transfer to at least 1 region (" . $response2["message"] . ").";
                }

            }
        }
        else
        {
            $result = "No regions found. " . $regions["message"];
        }

    }
    else
    {
        $result = "Could not get the snapshot id. " . $response["message"];
    }

    return $result;
}


